# File tres/Scripts/tnext.cl
# By Doug Mink
# April 22, 2009

# TNEXT -- Find next unused sequence number for new sum or average file

procedure tnext

int	nextseq=0	{prompt="Next available sequence number (returned)"}
string	nextstr=""	{prompt="Next sequence number as string (returned)"}
bool	verbose=no	{prompt="Print name of last sequence number (yes or no)"}
bool	debug=no	{prompt="Print information for debugging (yes or no)"}

struct *nextfiles

begin
    bool vb, db
    file rdir, imin, templist, imfile
    string filetemp, ddir, nstr
    int rawseq, procseq, seq
    int	minseq		# Minimum new sequence number

    vb = verbose
    db = debug

    tcheck

# Make list of files in raw data directory
    rdir = trsdate.rdir
    fixdir (rdir)
    rdir = fixdir.newdir
    filetemp = rdir // "0*"
    templist = mktemp ("tempfiles") // ".list"
    if (db) {
	print ("TNEXT: File template is ",filetemp)
	files (filetemp)
	}
    files (filetemp, >templist)

# Find highest numbered file in raw data directory
    rawseq = 0
    nextfiles = templist
    while (fscan (nextfiles, imin) != EOF) {
	filename (imin)
	imfile = filename.filename
	nstr = substr (imfile, 1, 4)
	isnum (nstr)
	if (isnum.fpcode > 0) {
	    seq =int (nstr)
	    if (seq > rawseq)
		rawseq = seq
	    }
	}
    if (vb)
	print ("TNEXT: Last raw sequence number is ", rawseq)

    delete (templist)
    filetemp = "*.fits"
    if (db) {
	print ("TNEXT: File template is ",filetemp)
	files (filetemp)
	}
    files (filetemp, >templist)

    procseq = 0
    nextfiles = templist
    while (fscan (nextfiles, imin) != EOF) {
	nstr = substr (imin, 1, 4)
	isnum (nstr)
	if (isnum.fpcode > 0) {
	    seq =int (nstr)
	    if (db)
		print (seq)
	    if (seq > procseq)
		procseq = seq
	    }
	}
    if (vb)
	print ("TNEXT: Last processed sequence number is ", procseq)

# Set next sequence number to highest number found plus one
    if (procseq > rawseq)
	nextseq = procseq + 1
    else
	nextseq = rawseq + 1

# If highest number found is less than minimum set in TRSDATE, use it
    minseq = trsdate.lastseq

# Fill in leading zeroes
    if (nextseq < minseq)
	nextseq = minseq
    else if (nextseq < 10)
	nextstr = "000" // nextseq
    else if (nextseq < 100)
	nextstr = "00" // nextseq
    else if (nextseq < 1000)
	nextstr = "0" // nextseq
    if (vb)
	print ("TNEXT: Next sequence number is ", nextstr)

    delete (templist)
    nextfiles = ""

end

# Mar  5 2009	New program
# Apr 22 2009	Add nextstr parameter = returned number with leading zeroes
# Apr 22 2009	Check all FITS files in working directory
