# TPREAMP - Run SPP version of Brian McCleod's preamplifier fix on raw images
# February 25, 2008
# By Doug Mink, SAO Telescope Data Center

procedure tpreamp (images)

string	images=""	{prompt="Images to process"}

bool	deltemp=yes	{prompt="Delete intermediate image files (y or n)"}
bool	saveold=yes	{prompt="Save unprocessed image files (y or n)"}
bool	verbose=yes	{prompt="Print process progress (yes or no)"}
bool	debug=no	{prompt="Print more process progress (yes or no)"}

struct *preampfiles
begin

file	imin, templist
string	ims
bool	vb, dt, db, sv

	vb = verbose
	dt = deltemp
	db = debug
	ims = images
	sv = saveold

	if (ims == "") {
	    print ("TPREAMP: Correct preamp problem for both amps one amp at a time")
	    print ("Usage: tpreamp <input images with 2 image extensions>")
	    return
	    }

#  Make temporary list of input files
	templist = mktemp ("tempamp") // ".list"
	files (ims, >templist)

# Correct list of files for preamp time constant
	preampfiles = templist
        while (fscan (preampfiles, imin) != EOF) {
	    tpreamp1 (imin,imdir=imd,deltemp=dt,saveold=sv,verbose=vb,debug=db)
	    }

	if (dt)
	    delete (templist)
	preampfiles = ""
end

# Jan 10 2008	New task based on hectospec.hpreamp
# Feb  8 2008	Save unprocessed images in Unpreamp/, not Raw/
# Feb 11 2008	Change name of temporary file from proclist* to tempamp*list
# Feb 20 2008	Always use files() to make a temporary list file
# Feb 25 2008	Move per file processing to task TPREAMP1
