# TSCAT -- Divide TRES images by pixel normalization file from tmakeflat
#          (apflatten), saving original files in Unflat/
# By Doug Mink, SAO Telescope Data Center
# April 29, 2009

procedure tscat (images)

string	images = ""	{prompt="Input TRES image(s) to correct"}
string  maskroot="flat" {prompt="Root file name for mask file"}
string  maskdir="tresdata$"     {prompt="Directory for mask file if not local"}
string  function="legendre"     {prompt="Function to fit to surface (legendre|chebyshev|spline3)"}
int     xorder = 2      {prompt="Order of function in x"}
int     yorder = 2      {prompt="Order of function in y"}
bool    crossterms = yes        {prompt="Include cross-terms for polynomials?"}
bool    saveold = yes   {prompt="Save original file to Unscat/ (yes or no)"}
bool    deltemp = yes   {prompt="Delete intermediate files (yes or no)"}
bool	verbose = yes	{prompt="Log progress (y or n)"}

struct	*scatlist

begin
	bool vb, sv, dt
	file imin, imnorm, templist, mdir
	string ims, mroot

	ims = images
	vb = verbose
	sv = saveold
	dt = deltemp
	mroot= maskroot
	mdir = maskdir
	fixdir (mdir)
	mdir = fixdir.newdir

#  Make temporary list of input files
        templist = mktemp ("tempscat") // ".list"
        files (ims, >templist)

# Set scattered light removal function
	tscat1.function = function
	tscat1.xorder = xorder
	tscat1.yorder = yorder
	tscat1.crossterms = crossterms
	tscat1.maskroot = mroot
	tscat1.maskdir = mdir

# Flatten images from list one at a time
        scatlist = templist
        while (fscan (scatlist,imin) != EOF) {
	    tscat1 (imin, deltemp=dt, saveold=sv, verbose=vb)
	    }

	if (deltemp) {
	    delete (templist)
	    }
	scatlist = ""
end

# Apr 20 2009	New task (based on TFLAT)
# Apr 29 2009	Set scatlist back to null string at end of task
