# TXDISP - Run ds9 on raw TRES image files, one file at a time
# May 9, 2009
# By Doug Mink, SAO Telescope Data Center

procedure txdisp (images)

string	images=""	{prompt="Images to check"}

bool	background=yes	{prompt="Run in background (yes or no)"}
string	options=""	{prompt="DS9 command line options"}
int	maximages=4	{prompt="Maximum number of images to display in background"}
bool	deltemp=yes	{prompt="Delete intermediate image files (yes or no)"}
bool	verbose=yes	{prompt="Print process progress (yes or no)"}

begin

int	iext, nimg, maximg
file	templist, imin
string	ims, imlist, opt
bool	vb, first, bg

	vb = verbose
	ims = images
	first = yes
	bg = background
	opt = options
	maximg = maximages

	if (ims == "") {
	    print ("TXDISP:  Display raw TRES images using ds9")
	    print ("Usage: txdisp <input images with 2 extensions>")
	    return
	    }

# If input image is a list prepend @ if not already there
	smatch (ims, ".list")
	if (smatch.found) {
	    if (substr (ims,1,1) != '@')
		ims = "@" // ims
	    }

#  Make temporary list of input files
	trsfiles (ims)
	if (trsfiles.nfiles == 0) {
	    delete (trsfiles.tempin)
	    if (vb)
		print ("TXDISP: No files found: ", ims)
	    return
	    }
	templist = trsfiles.tempout
	nimg = 0
	list = templist
        while (fscan (list,imin) != EOF) {
	    args = "-mosaicimage "
	    if (opt != "")
		args = args // opt // " "
	    args = args // imin
	    nimg = nimg + 1
	    if (bg && nimg <= maximg)
		args = args // " &"
	    tds9 (args)
	    }

	if (deltemp) {
	    delete (templist)
	    delete (trsfiles.tempin)
	    }
end

# Mar  9 2009	New task to display TRES raw images by file or sequence num.
# May 15 2009	Add background parameter to optionally display in background
# May 16 2009	Add options parameter to allow interestin display format
